Attribute VB_Name = "Stitcher"
' "AntonMacros"

'      2  5   4.
'  1.3. (C) .

DefStr C, H, S
DefInt I-K
DefLng L-N
DefSng X
DefBool Y

'       ,    :
Const OuterMargin! = 1.9, InnerMargin! = 1.6  ' []
    '    :
    '  (2.5, 2.0),  (1.9, 1.6),  (1.3, 1.1)

Const xSum = OuterMargin+InnerMargin
Const xPoints = 28.35  ' 1  

Const Y = True, CR = vbCr, Cr2 = CR & CR
Const Tb2$ = vbTab & vbTab, Tb3$ = vbTab & Tb2
Const Aim$ = "      2  5   4." & CR
Const Confirm = Cr2 & " ""OK""    "
Const Cancelled = " !"
Const ModuleName$ = "Stitcher -- "
Const SubName = "Stitcher_PrintManager"
Const Hlp0 = "  ", HidTxt = "   "
Const ReFeed$ = "     , "
Const ReFeed2$ = ReFeed & "   "
Const FrontPgs$ = "ר  ."
Const BackPgs$ = "ר  ."

Const Verbose% = 0   '  (Y)   (0)  "[...]"
'

Sub Stitcher()
Attribute Stitcher.VB_Description = ". (C) ."
' 

If InnerMargin < 0.4 Or OuterMargin < InnerMargin Or xSum > 11.8 _
    Then Err.Raise 380, ModuleName, "     ." & CR & "    ."

If 1 < MsgBox(Hlp0 & "     " & Aim _
	& "         """" ." _
	& Cr2 & "       ,   -       ." _
	& Cr2 & "     ?", _
	33, ModuleName) _
    Then StatusBar = Cancelled: Exit Sub

Old_OptionRS% = Options.ReplaceSelection
Options.ReplaceSelection = Y
SpcTabEL = " " & vbTab & Chr(11) & ChrW(21)
SpcTabELCR = SpcTabEL & CR

PrintPreview = 0
With ActiveWindow.View
    If .SplitSpecial>0 Then .Parent.Panes(2).Close
monitor 0
    .Type = 3 'Pg
    .Zoom.PageFit = 2

With ActiveDocument.PageSetup
    .TextColumns.SetCount 1
    .MirrorMargins = Y
    .Gutter = 0
    .RightMargin = 0: .LeftMargin = 0
    .Orientation = 1
    .RightMargin = OuterMargin * xPoints	  '  ->  
    .LeftMargin = (InnerMargin+14.85) * xPoints ' (1/2  ) = 14.85
    .OddAndEvenPagesHeaderFooter = Y
    .DifferentFirstPageHeaderFooter = 0
End With

    .Type = 1 'Normal
    .ShowFieldCodes = 0

With Selection
    NumPg = .Information(4)
    Numsheets = Int((3+NumPg) / 4)
    j = Numsheets * 4 - NumPg
    If NumPg<5 Then MsgBox "     ." _
		& Cr2 & "       !" _
		, 64, ModuleName
    If j>1 Then MsgBox ":     " _
		& CR & j & "  ." _
		& Cr2 & ",     -  (, ,  ...) , , - ,     ?" _
		, 64, ModuleName
    L2 = .GoTo(1, 1, 2).Start 'Page2
    .End = 0
    .MoveStartWhile SpcTabELCR
    .MoveEnd 4  ' 
    .MoveEndWhile SpcTabELCR, wdBackward
'(     ,   .)
    L1 = .End
    Do Until L1 >= L2
	If .Characters.Count - .Fields.Count < 46 Then
	    Header = .Text
	    L0 = .Start
	    L_H1 = Len(Header)
	    Set Pg1_Header1 = .FormattedText
	    If L_H1>41 Then Exit Do
	End If
	If .Paragraphs(1).OutlineLevel < 10 Then Exit Do

'   ,     1- :
	.GoToNext wdGoToHeading
	.MoveEnd 4
	.MoveEndWhile SpcTabELCR, wdBackward
	.MoveStartWhile SpcTabEL
	If .Type = 1 Or .Start <= L1 Or .End >= L2 Or L_H1 + .Characters.Count - .Fields.Count > 45 Then Exit Do
	If L_H1>0 Then H_dot = IIf(Right$(Header, 1) = ".", "  ", ".  ")
	Set Pg1_Header2 = .FormattedText
	Header = Header & H_dot & .Text
	Exit Do
    Loop
    L_H = Len(Header)
    StatusBar = "         ."
monitor Y
    If L_H>0 Then If 1 < MsgBox(Header, 33, "      . ?") Then L_H = 0: L_H1 = 0
    StatusBar = IIf(L_H>0, Header, "      .")
End With  ' Selection


' ,    

    Header_and_Footer_Styles_Redefiner
    .SeekView = 0 'Main

    .Type = 1
monitor 0

With ActiveDocument
    With .Sections(1)
	.PageSetup.DifferentFirstPageHeaderFooter = Y
	.Headers(2).Range.Delete  ' 1- .
	.Footers(2).Range.Delete
	Tab2_PageField .Headers(1), Y ' 
	Tab2_PageField .Footers(1), 0
	.Headers(3).Range.Select  ' 
	DefaultStyle
	With Selection
	    .Delete
	    .TypeText "= min(": PageField: .TypeText ";"
	    NewField_U wdFieldNumPages
	    .InsertBefore "= int((3+"
	    .InsertAfter ")/4)"
	    NewField_U
	    .Bookmarks.Add "Numsheets", Selection
	    .Move 6 'Story
	    .TypeText "*4+2-": PageField: .TypeText ")/2"
	    .Start = 0: NewField
	    .Move
	    PageField
	    .MoveStart , -1
	    .InsertBefore "= if("
	    .InsertAfter ">Numsheets*2;1;2)"
	    NewField
	    .InsertBefore "," & vbTab & " "
	    .InsertAfter "]"
	    .Font.Hidden = Y
	    .End = .Start+10: .Font.Size = 8
	    .End = 0: .TypeText Tb3 & "[ "
	    .Start = 4: .Font.Size = 8
	    .MoveEnd: If Verbose Then .End = 4
	    .Start = 3: .Font.Hidden = Y ' "["
	    .End = 0: PageField
	    .Start = 0: .Font.Hidden = Y
	End With
	.Footers(3).Range.Select  ' 
	DefaultStyle
	With Selection
	    .TypeText Tb3 & "IF  <  "","""
	    .MoveLeft
	    .InsertSymbol 8194,, Y ' EnSpace
	    .Fields.Add .Range, wdFieldDate, "\@ ""yyyy .""", 0
	    .End = 6: PageField
	    .Move , 3 '<
	    NewField_U wdFieldNumPages
	    .InsertBefore "= "
	    NewField_U
	    .WholeStory: .Start = 3 '{IF}
	    NewField
	    .End = 1: .TypeText H_dot
	    If L_H>L_H1 Then .FormattedText = Pg1_Header2
	    .End = 1: If L_H1>0 Then .FormattedText = Pg1_Header1
	    .End = 0: PageField
	    .WholeStory: .Font.Reset
'            :
	    '.Move: .MoveStart , -1: .Font.Hidden = Y
	End With
    End With  'Sec(1)
    For n = 2 To .Sections.Count
	With .Sections(n)
	    For j = 1 To 3
		.Headers(j).LinkToPrevious = Y
		.Footers(j).LinkToPrevious = Y
	    Next j
	End With
    Next n
On Error Resume Next
    .Variables("Numsheets").Delete
    .Variables("NumPg").Delete
On Error GoTo 0
    .Variables.Add "Numsheets", Numsheets
    .Variables.Add "NumPg", NumPg
    Set Fields = .Fields
End With  ' Doc

    If .SplitSpecial>0 Then .Parent.Panes(2).Close
    YN = .ShowHiddenText Or .ShowAll
    .ShowFieldCodes = 0
monitor Y
Fields.Update
Fields.Update
    With .Parent.Panes(1).Zooms(4) '-   -  ,   :((
	.Percentage = 62
	.PageFit = 2
    End With
PrintPreview = Y
    .Zoom.Percentage = 62
    .Zoom.PageFit = 2
End With  ' AWV


StatusBar = "  "
With Options
    .ReplaceSelection = Old_OptionRS
    .PrintDraft = 0
    MsgBox "  " & Aim _
	& "  ,       (  ).  -   ,      ,     (  !)." _
	& Cr2 & ",       .       ,       ,        ." _
	& Cr2 & "    ( """",  """",  """"  """")   ,      ." _
	& CR & "  :" _
	& CR & " --     " & HidTxt _
	& IIf(YN, ";", " ;") _
	& CR & " --  " & HidTxt & " " & IIf(.PrintHiddenText, ".", ".") _
	& Cr2 & " ,  Stitcher_PrintManager." _
	, 64, ModuleName
End With

End Sub

Sub DefaultStyle()
Attribute DefaultStyle.VB_Description = "      ,    . (C) ."
'       ,    
Selection.Style = Choose(5293 Mod (0.6 * Selection.Information(33) + 10.6), -33, -32, -66)
End Sub

Sub Header_and_Footer_Styles_Redefiner()
Attribute Header_and_Footer_Styles_Redefiner.VB_Description = "      . (C) ."
'       

On Error Resume Next
' (  Word'   SeekView )

With ActiveWindow.ActivePane.View

    .Type = 3 'Pg

    .SeekView = 1 'P_H
    .SeekView = 3 'EvenP_H

' TabPos [cm]:
    x1 = (13.7-xSum) / 2#
    x2 = 13.85-xSum
    x3 = 14.9-xSum
    x4 = 14.8 - (OuterMargin-InnerMargin)
    x5 = 28.7 - (OuterMargin * 2#)
'   (1.9,1.6): {_5.1_,10.35|, |11.4, 14.5|, 24.9|}
'  : [0=|, 1=__, 2=|]
Style_Redefiner wdStyleHeader, 12, 0, 1#, 1#, x1, 1, x2, 2, x3, 0, x4, 2, x5, 2

    .SeekView = 4 'P_F
    .SeekView = 6 'EvenP_F

    x1 = 13.5-xSum
    x3 = (x4+x5-0.1) / 2#
'   (1.9,1.6): {10|,10.35|, _19.65_, 24.9|}
Style_Redefiner wdStyleFooter, 9, 0, 1#, 1#, x1, 2, x2, 2, x3, 1, x5, 2
End With
End Sub

Private Sub Style_Redefiner(int_num, MaxSize, xL, x1, xR, ParamArray Tabs())
'       :   FontSz;Left,1st,Right;    {Position_in_CM, WdTabAlignment}

If Verbose Then Style_Informator int_num, " "
monitor 0

With ActiveDocument.Styles(int_num)
    .AutomaticallyUpdate = 0
    If .Font.Size>MaxSize Then .Font.Size = MaxSize
    Set PF = .ParagraphFormat.Duplicate

With PF
    .Alignment = 0  'Left
    .LeftIndent = xPoints * xL
    .FirstLineIndent = xPoints * x1
    .RightIndent = xPoints * xR
    .Hyphenation = 0
    .TabStops.ClearAll
    For i = 1 To UBound(Tabs()) Step 2
	.TabStops.Add Tabs(i-1) * xPoints, Tabs(i)
		    ' TabPosition[cm]	,    TabAlignment[0|1|2]
    Next
End With 'PF

    .ParagraphFormat = PF
End With 'ADS

If Verbose Then Style_Informator int_num, " "
End Sub

Sub Style_Informator(Optional BuiltIn_Style_num, Optional Text)
Attribute Style_Informator.VB_Description = "    . (C) ."

monitor Y

n = Val(CStr(BuiltIn_Style_num))
With IIf(n, ActiveDocument.Styles(IIf(n, n, 1)), Selection.Paragraphs.Style)
    With .ParagraphFormat
	ParaParams$ _
	= StrVal("Left", .LeftIndent) _
	& StrVal("First", .FirstLineIndent) _
	& StrVal("Right", .RightIndent)
    End With
    MsgBox " " & IIf(IsMissing(Text), ":", " " & CStr(Text)) _
	& Cr2 & .Description & ";" & Cr2 _
	& StrVal("FontSize", .Font.Size) & ParaParams, _
	, .NameLocal & " (AutoUpdate=" & .AutomaticallyUpdate & ", BuiltIn=" & .BuiltIn & ")"
End With
End Sub

Function StrVal(h, x)
StrVal = Right$(Space$(15) & h, 15) & ":        " & x & "=" & Format$(PointsToCentimeters(x), "###0.0#") & CR
End Function

Sub Tab2_PageField(Obj As Object, Mode)
'      ,
'       
Obj.Range.Select
DefaultStyle
With Selection
    PageField
    .Start = 0: .Font.Hidden = Mode
    .InsertBefore Tb2
End With
End Sub

Private Sub PageField()
NewField 33
With Selection
    .InsertAfter "."
    .Font.Reset
    .Move: .Delete , -1
End With
End Sub

Private Sub NewField(Optional Which)
Selection.Fields.Add(Selection.Range, Which,, 0).Select
End Sub

Private Sub NewField_U(Optional Which)
NewField Which
Selection.Fields.Update
End Sub

Sub monitor(YN)
Application.ScreenUpdating = YN
End Sub

Sub Stitcher_PrintManager()
Attribute Stitcher_PrintManager.VB_Description = "     4 . (C) ."
'      4 

Dim HP_LJ As Boolean: HP_LJ = InStr(ActivePrinter, "HP LaserJet 2200") = 1

'       ,
'       :
'    HP_LJ = Y

yonder = ActivePrinter <> ""
PrinterName$ = IIf(yonder, "  : '" & ActivePrinter & "'", ":      !!")
StatusBar = PrinterName

NumPg = Selection.Information(4)
Numsheets = Int((3+NumPg) / 4)
j = Numsheets Mod 100:  j = IIf(j<5 Or j>20, (j+8) Mod 10, 8)

With ActiveDocument
On Error Resume Next
    Yes = .PageSetup.MirrorMargins And _
	.PageSetup.Orientation = 1 And _
	.Variables(2).Name = "Numsheets" And _
	.Variables(1).Name = "NumPg" And _
	.Variables(1).Value = NumPg And _
	.Variables(2).Value = Numsheets
On Error GoTo 0
    If Not Yes Then
	StatusBar = Cancelled
	MsgBox Hlp0 & "      " _
	    & CR & ModuleName & "." _
	    & Cr2 & "    (    ..)  " _
	    & ModuleName & "  ." _
	    , 16, SubName
	Exit Sub
	End If
    If 1 < MsgBox(Hlp0 & "    ." _
	    & CR & "             ." _
	    & Cr2 & PrinterName _
	    & Cr2 & "  ?", _
	    IIf(yonder, 33, 273), SubName) _
	Then StatusBar = Cancelled: Exit Sub
PrintPreview = 0
    n2 = Numsheets * 2
    n4 = n2 * 2
With Selection
    .GoTo 1, -1
    .EndKey 6
    While .Information(4) < n4: .InsertBreak 7
    Wend
End With
With Options
    .PrintDrawingObjects = Y
    .PrintProperties = 0
    .PrintComments = 0
    .PrintFieldCodes = 0
    .UpdateFieldsAtPrint = Y
End With
    QPrt 1, HP_LJ, 1, n2, _
	" ,    " _
	& Numsheets & " " & Choose((j+9) \ 6, "", "", "") _
	& "   ,     ,            ." _
	& Confirm & "" & FrontPgs
    QPrt 2, Y, n2+2, n4, _
	ReFeed2 & "  ." _
	& Confirm & FrontPgs
    QPrt 2, Not HP_LJ, 2, n2, _
	ReFeed & "       """": 1-       ." _
	& Confirm & BackPgs
    QPrt 1, 0, n2+1, n4, _
	ReFeed2 & "   ." _
	& Confirm & "" & BackPgs
    While Yes And Selection.Information(4) > NumPg
	Yes = .Undo
    Wend
    .UndoClear
End With
MsgBox "      ,      !" _
	, 48, SubName
End Sub

Sub QPrt(ind_1_2, YN, n1, n2, help)
Options.PrintReverse = YN
MsgBox help, 64, SubName
ActiveDocument.PrintOut 0,, 3,, Str(n1), Str(n2),,,, ind_1_2
End Sub
